#ifndef HD512DLL_H
#define HD512DLL_H


#define Decl extern  "C"  __declspec(dllimport) __stdcall

//===========================================================================

//-------------------------------------------------------------
// ShowAbout and Version
//-------------------------------------------------------------
Decl void ShowAbout();


//-------------------------------------------------------------------------
//  Check DMX Dongle
//  True have Dongle
//-------------------------------------------------------------------------
Decl bool isDMXOpen();


//-----------------------------------------------------------------------------------------
//  Close Dongle
//-----------------------------------------------------------------------------------------
Decl void DMXClose();


//---------Send Single Channel Value to Dongle---------------------------
//              Channel(1512)
//              Value(0255)
//----------------------------------------------------------------------
Decl bool DMXSend(long Channel, unsigned char Value);


//---------------------------Bulk send----------------------------------------------------
//            ChannelCount(1~512)
//            ChannelIndex(1~512) First Channel Value
//            Value=buff datas
//            DMXSends(512,1,buff); //Send All 512 channels data to HD512 (data in buff)
//-------------------------------------------------------------------------------------------
Decl bool DMXSends(long ChannelCount, long ChannelIndex, unsigned char* Value);


//---------Other way Send Single Channel Value to Dongle---------------------------
//              Channel(1512)
//              Value(0255)
//----------------------------------------------------------------------
Decl bool DMXSendSingleChannel(long Channel, unsigned char Value);


//---------------------------can send DMX data to 0~3 universe ID box------------------------------
//            Value=buff[512] datas
//            Box = 0~3  universe ID
//            DMXSendBox(2,buff); //Send All 512 channels data to universe2[box3] HD512 box (data in buff)
//--------------------------------------------------------------------------------------------------
Decl bool DMXSendBox(long Box, unsigned char* Value); 



//--------------------------------------Change Box Number----------------------------------------------------------
//when want 1~4 box combinations work 1024~2048 channels, must changer box number, one box don't use this function,
//            Box = 0~3  box number 
//            ChangeBoxNumber(1); //have two box make 1024 channels.
//-----------------------------------------------------------------------------------------------------------------
Decl bool ChangeBoxNumber(long Box);



//-----------------------Get Box Number-----------------------------------------------
//                       Get box number
//------------------------------------------------------------------------------------
Decl int  GetBoxNumber();


//-----------------------Get Box Universe ID------------------------------------------
//                  only for one box, Get Box Universe ID
//------------------------------------------------------------------------------------
Decl char GetBoxUniverseID();


//-----------------------Get Box Refresh Rate------------------------------------------
//                       only for one box
//-------------------------------------------------------------------------------------
Decl int  GetBoxRefreshRate();


//-----------------------Set Box Refresh Rate------------------------------------------
//                         only for one box
//                        DlyTime = 1000 / Rate , 22ms = 1000 / 44Hz
//-------------------------------------------------------------------------------------
Decl bool SetBoxRefreshRate(int DlyTime);    

//===========================================================================

#endif


